<?php
class ControllerModuleGCheckout extends Controller {
	var $error = array();
	 
	function index() { 
		$this->load->language('module/gcheckout');
		$this->document->title = $this->language->get('heading_title');
		$this->load->model('setting/setting');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('gcheckout', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->redirect($this->https('extension/module'));
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_left'] = $this->language->get('text_left');
		$this->data['text_right'] = $this->language->get('text_right');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');
		
		$this->data['entry_position'] = $this->language->get('entry_position');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_merchantid'] = $this->language->get('entry_merchantid');
		$this->data['entry_merchantkey'] = $this->language->get('entry_merchantkey');
		$this->data['entry_test'] = $this->language->get('entry_test');
		$this->data['entry_currency'] = $this->language->get('entry_currency');
		$this->data['entry_merchant_calculation'] = $this->language->get('entry_merchant_calculation');
		$this->data['entry_merchant_calculation_url'] = $this->language->get('entry_merchant_calculation_url');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

 		if (isset($this->error['merchantid'])) {
			$this->data['error_merchantid'] = $this->error['merchantid'];
		} else {
			$this->data['error_merchantid'] = '';
		}

 		if (isset($this->error['merchantkey'])) {
			$this->data['error_merchantkey'] = $this->error['merchantkey'];
		} else {
			$this->data['error_merchantkey'] = '';
		}

 		if (isset($this->error['merchant_calculation_url'])) {
			$this->data['error_merchant_calculation_url'] = $this->error['merchant_calculation_url'];
		} else {
			$this->data['error_merchant_calculation_url'] = '';
		}

  		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->https('common/home'),
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->https('extension/module'),
       		'text'      => $this->language->get('text_module'),
      		'separator' => ' :: '
   		);
		
   		$this->document->breadcrumbs[] = array(
       		'href'      => $this->https('module/gcheckout'),
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
		);
		
		$this->data['action'] = $this->https('module/gcheckout');
		
		$this->data['cancel'] = $this->https('extension/module');

		if (isset($this->request->post['gcheckout_geo_zone_id'])) {
			$this->data['gcheckout_geo_zone_id'] = $this->request->post['gcheckout_geo_zone_id'];
		} else {
			$this->data['gcheckout_geo_zone_id'] = $this->config->get('gcheckout_geo_zone_id');
		}
		
		if (isset($this->request->post['gcheckout_merchantid'])) {
			$this->data['gcheckout_merchantid'] = $this->request->post['gcheckout_merchantid'];
		} else {
			$this->data['gcheckout_merchantid'] = $this->config->get('gcheckout_merchantid');
		}
		
		if (isset($this->request->post['gcheckout_merchantkey'])) {
			$this->data['gcheckout_merchantkey'] = $this->request->post['gcheckout_merchantkey'];
		} else {
			$this->data['gcheckout_merchantkey'] = $this->config->get('gcheckout_merchantkey');
		}
		
		if (isset($this->request->post['gcheckout_test'])) {
			$this->data['gcheckout_test'] = $this->request->post['gcheckout_test'];
		} else {
			$this->data['gcheckout_test'] = $this->config->get('gcheckout_test');
		}
		
		if (isset($this->request->post['gcheckout_currency'])) {
			$payment_info = $this->request->post['gcheckout_currency'];
		} else {
			$payment_info = $this->config->get('gcheckout_currency');
		}
		
		if (isset($this->request->post['gcheckout_merchant_calculation'])) {
			$this->data['gcheckout_merchant_calculation'] = $this->request->post['gcheckout_merchant_calculation'];
		} else {
			$this->data['gcheckout_merchant_calculation'] = $this->config->get('gcheckout_merchant_calculation');
		}
		
		if (isset($this->request->post['gcheckout_merchant_calculation_url'])) {
			$this->data['gcheckout_merchant_calculation_url'] = $this->request->post['gcheckout_merchant_calculation_url'];
		} else if ($this->config->get('gcheckout_merchant_calculation_url')) {
			$this->data['gcheckout_merchant_calculation_url'] = $this->config->get('gcheckout_merchant_calculation_url');
		} else {
			$url = $this->config->get('config_url');
			if ($this->config->get('config_ssl')) {
				$url = 'https://' . substr($this->config->get('config_url'), 7);
			}
			$this->data['gcheckout_merchant_calculation_url'] = $url.'index.php?route=checkout/gcheckout/callback';
		}
		
		if (isset($this->request->post['gcheckout_position'])) {
			$this->data['gcheckout_position'] = $this->request->post['gcheckout_position'];
		} else {
			$this->data['gcheckout_position'] = $this->config->get('gcheckout_position');
		}
		
		if (isset($this->request->post['gcheckout_status'])) {
			$this->data['gcheckout_status'] = $this->request->post['gcheckout_status'];
		} else {
			$this->data['gcheckout_status'] = $this->config->get('gcheckout_status');
		}
		
		if (isset($this->request->post['gcheckout_sort_order'])) {
			$this->data['gcheckout_sort_order'] = $this->request->post['gcheckout_sort_order'];
		} else {
			$this->data['gcheckout_sort_order'] = $this->config->get('gcheckout_sort_order');
		}
		
		$currency_data = array();
		
		$currency_data[] = array(
			'text'     => $this->language->get('text_gbp'),
			'value'    => 'GBP',
			'selected' => (('GBP'==$payment_info) || ('USD'!=$payment_info))
		);

		$currency_data[] = array(
			'text'     => $this->language->get('text_usd'),
			'value'    => 'USD',
			'selected' => ('USD'==$payment_info)
		);

		$this->data['currencies'] = $currency_data;
		$this->load->model('localisation/geo_zone');
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		$this->template = 'module/gcheckout.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}


	private function validate() {
		if (!$this->user->hasPermission('modify', 'module/gcheckout')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (trim($this->request->post['gcheckout_merchantid'])=='') {
			$this->error['merchantid'] = $this->language->get('error_merchantid');
		}

		if (trim($this->request->post['gcheckout_merchantkey'])=='') {
			$this->error['merchantkey'] = $this->language->get('error_merchantkey');
		}

		if (isset($this->request->post['gcheckout_merchant_calculation_url'])) {
			if (trim($this->request->post['gcheckout_merchant_calculation_url'])!='') {
				$url = trim($this->request->post['gcheckout_merchant_calculation_url']);
				if ((!$this->startsWith( $url, 'https://' )) && (!$this->startsWith( $url, 'http://' ))) {
					$this->error['merchant_calculation_url'] = $this->language->get('error_merchant_calculation_url');
				}
			}
		}

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}

	private function http($route) {
		return HTTP_SERVER . 'index.php?route=' . str_replace('&', '&amp;', $route.'&token=' . $this->session->data['token'].'&token=' . $this->session->data['token']);
	}

	private function https($route) {
		if (HTTPS_SERVER != '') {
			$link = HTTPS_SERVER . 'index.php?route=' . str_replace('&', '&amp;', $route.'&token=' . $this->session->data['token']);
		} else {
			$link = HTTP_SERVER . 'index.php?route=' . str_replace('&', '&amp;', $route.'&token=' . $this->session->data['token']);
		}
				
		return $link;
	}

	public function startsWith( $haystack, $needle ) {
		if (strlen( $haystack ) < strlen( $needle )) {
			return FALSE;
		}
		return (substr( $haystack, 0, strlen($needle) ) == $needle);
	}


	public function install() {
		$this->load->model('module/gcheckout');
		$this->model_module_gcheckout->createDatabaseTables();
	}


	public function uninstall() {
		$this->load->model('module/gcheckout');
		$this->model_module_gcheckout->dropDatabaseTables();
	}



}
?>